#include "MyWindow.h"

#include <QtWidgets/QMessageBox>
#include <QtWidgets/QInputDialog>

MyWindow::MyWindow(QWidget *parent)
    :
    QMainWindow(parent)
{
    createAction();
    createMenu();

    setWindowTitle("brlcad");
    resize(800, 500);
    QRect screen = QApplication::desktop()->screenGeometry();
    int x = (screen.width() - width()) / 2;
    int y = (screen.height() - height()) / 2;
    move(x, y);
}

void MyWindow::setTitleFromDatabase(const char *path)
{
    struct rt_i *rtip;
    char title[1024] {};

    rtip = rt_dirbuild(path, title, sizeof(title));

    if (rtip == RTI_NULL) {
        QMessageBox::information(this, "", "error while setting title");
        return;
    }

    setWindowTitle(QString(title));
}

void MyWindow::createMenu()
{
    brlcadMenu = menuBar()->addMenu("&BRL-CAD");
    brlcadMenu->addAction(brlcadTitleAction);
}

void MyWindow::createAction()
{
    brlcadTitleAction = new QAction("&Set title", this);
    connect(brlcadTitleAction, &QAction::triggered, this, &MyWindow::setTitleAction);
}

void MyWindow::setTitleAction()
{
    const QString &input = QInputDialog::getText(0, "Set title",
                                                 "database path");
    
    setTitleFromDatabase(input.toStdString().c_str());
}
